.TH XLOGO 1 "Release 5" "X Version 11"
.SH NAME
xlogo - X Window System logo
.SH SYNOPSIS
.B xlogo
[-\fItoolkitoption\fP ...]
.SH DESCRIPTION
The \fIxlogo\fP program displays the X Window System logo.  This program is
nothing more than a wrapper around the \fIundocumented\fP Athena Logo widget.
.SH OPTIONS
.I Xlogo
accepts all of the standard X Toolkit command line options, as well as the
following:
.TP 8
.B \-shape
This option indicates that the logo window should be shaped rather than
rectangular.
.SH RESOURCES
The default width and the default height are each 100 pixels.
This program uses the \fILogo\fP widget in the Athena widget set.  It
understands all of the Simple widget resource names and classes as well as:
.TP 8
.B foreground (\fPclass\fB Foreground)
Specifies the color for the logo.  The default is depends on whether
\fIreverseVideo\fP is specified.  If \fIreverseVideo\fP is specified
the default is \fIXtDefaultForeground\fP, otherwise the default is 
\fIXtDefaultBackground\fP.
.TP 8
.B shapeWindow (\fPclass\fB ShapeWindow) 
Specifies that the window is shaped to the X logo.  The default is False.
.SH WIDGETS
In order to specify resources, it is useful to know the hierarchy of
the widgets which compose \fIxlogo\fR.  In the notation below,
indentation indicates hierarchical structure.  The widget class name
is given first, followed by the widget instance name.
.sp
.nf
.TA .5i 
.ta .5i 
XLogo  xlogo
	Logo  xlogo
.fi
.sp
.SH ENVIRONMENT
.TP 8
.B DISPLAY
to get the default host and display number.
.TP 8
.B XENVIRONMENT
to get the name of a resource file that overrides the global resources
stored in the RESOURCE_MANAGER property.
.SH FILES
/usr/lib/X11/app-defaults/XLogo - specifies required resources
.SH SEE ALSO
X(1), xrdb(1)
.SH COPYRIGHT
Copyright 1988, Massachusetts Institute of Technology.
.br
See \fIX(1)\fP for a full statement of rights and permissions.
.SH AUTHORS
Ollie Jones of Apollo Computer and Jim Fulton of the MIT X Consortium
wrote the logo graphics routine, based on a graphic design by Danny
Chong and Ross Chapman of Apollo Computer.
