.TH XLSATOMS 1 "Release 5" "X Version 11"
.SH NAME
xlsatoms - list interned atoms defined on server
.SH SYNOPSIS
.B xlsatoms
[-options ...]
.SH DESCRIPTION
.I Xlsatoms
lists the interned atoms.  By default, all atoms starting from 1 (the lowest
atom value defined by the protocol) are listed until unknown atom is found.
If an explicit range is given, \fIxlsatoms\fP will try all atoms in the range,
regardless of whether or not any are undefined.
.SH "OPTIONS"
.PP
.TP 8
.B \-display \fIdpy\fP
This option specifies the X server to which to connect.
.TP 8
.B \-format \fIstring\fP
This option specifies a \fIprintf\fP-style string used to list each atom
\fI<value,name>\fP pair, printed in that order (\fIvalue\fP is an \fIunsigned
long\fP and \fIname\fP is a \fIchar *\fP).  \fIXlsatoms\fP will supply a
newline at the end of each line.  The default is \fI%ld\\t%s\fP.
.TP 8
.B \-range \fI[low]-[high]\fP
This option specifies the range of atom values to check.  If \fIlow\fP is not
given, a value of 1 assumed.  If \fIhigh\fP is not given, \fIxlsatoms\fP will
stop at the first undefined atom at or above \fIlow\fP.
.TP 8
.B \-name \fIstring\fP
This option specifies the name of an atom to list.  If the atom does not 
exist, a message will be printed on the standard error.
.PP
.SH "SEE ALSO"
X(1), Xserver(1), xprop(1)
.SH ENVIRONMENT
.TP 8
.B DISPLAY
to get the default host and display to use.
.SH COPYRIGHT
Copyright 1989, Massachusetts Institute of Technology.
.br
See \fIX(1)\fP for a full statement of rights and permissions.
.SH AUTHOR
Jim Fulton, MIT X Consortium
