'\" t
.\" $XConsortium: CTWC.man,v 1.1 91/10/08 15:11:21 rws Exp $
.\" Copyright 1990 by OMRON Corp.  All Rights Reserved.
.TH CTandWC 3X11 "Release 5" "X Version 11" "XSI FUNCTIONS"
.SH NAME
CT and WC \- compound text and wide character encoding
.SH DESCRIPTION
.PP
In this implementation the communication codeset is Compound Text
encoding, abbreviated to
.B CT,
the internal processing codeset is wide
character encoding, abbreviated to
.B WC.
The CT and WC occuring wherever
in this implementation is defined as following:
.IP [1]
The CT encoding conforms with X standard document "Compound Text
Encoding, Version 1.1" except:
.sp
  Section 7.  Directionality
  Section 10. Extensions
.IP
The CT string is terminated with null character.
.IP [2]
The WC is restricted to the following part of ISO DIS 10646(UCS):
.sp
.TS
l1 l.
*	canonical form, 4 octets(4-byte: group/plane/row/cell).
*	in the next sentences all number is decimal, and default group
	is 032, plane is 032.
*	row 032 for ISO 8859-1(L.2,p18) 
*	right-hand half of row 033 for right half of ISO8859-2(L4,p18) 
*	right-hand half of row 040 for right half of ISO8859-5(S25.2,p19)
*	right-hand half of row 042 for right half of ISO8859-7(S26.2,p19)
*	right-hand half of row 044 for right half of ISO8859-6(S27.1,p19)
*	left-hand half of row 059 for JIS X 0201(Private Use zone)
*	I-11, plane 048 of group 032 for Chinese GB 2312(S9,p9)
*	I-11, plane 064 of group 032 for Japanese JIS X 0208(S10,p9)
*	I-10, plane 064 of group 032 for Japanese JIS X 0212(S10,p9)
*	plane 080 of group 032 for Korean KS C5601(S10,p9)
.TE
.IP
where the numbers in paranthesis are line#(L), section#(S) and page#(p)
in document of ISO DIS 10646(UCS), 4 November 1990.
.IP
The other registered charset in CT are put on the following place of 
DIS 10646.
.sp
.TS
l1 l.
*	right-hand half of row 034 for right half of ISO8859-3
*	right-hand half of row 035 for right half of ISO8859-4
*	right-hand half of row 036 for right half of ISO8859-9
.TE
.IP
The following Private Use planes and zones are used for User
Defined Character(UDC):
.sp
.TS
l1 l.
*	planes 224 of group 032 to 255(32 planes)
*	left-hand half of row 052 of plane 032 of group 032 to 059(8 rows)
.TE
.IP
The WC string is terminated with WNULL character.  The WNULL is 
implementation-defined. 
.IP [3]
Conversion between WC and CT.
.IP
The conversion between WC and CT will be done accoding to the above
correspondency.  In CT a charset can be designated both to graphic
left(GL) and to graphic right(GR); in WC there is no such GL and GR.
So the conversion function translates GL and GR of CT to same place
of WC.  In the reverse, the conversion function always translates
the WC to the GL of CT as following:
.sp
.TS
l1 l.
*	plane 048 of Chinese to "ESC$(A", not "ESC$)A"
*	plane 064 of Japanese to "ESC$(B", not "ESC$)B"
*	plane 080 of Korean to "ESC$(C", not "ESC$)C"
*	others one to one, no ambigious.
.TE
.SH SEE ALSO
ISO DIS 10646(UCS), 4 November 1990.
.br
Compound Text Encoding, Version 1.1, X11R5.
