.ds xT X Toolkit Intrinsics \- C Language Interface
.ds xW Athena X Widgets \- C Language X Toolkit Interface
.ds xL Xlib \- C Language X Interface
.ds xC Inter-Client Communication Conventions Manual
.na
.de Ds
.nf
.\\$1D \\$2 \\$1
.ft 1
.\".ps \\n(PS
.\".if \\n(VS>=40 .vs \\n(VSu
.\".if \\n(VS<=39 .vs \\n(VSp
..
.de De
.ce 0
.if \\n(BD .DF
.nr BD 0
.in \\n(OIu
.if \\n(TM .ls 2
.sp \\n(DDu
.fi
..
.de FD
.LP
.KS
.TA .5i 3i
.ta .5i 3i
.nf
..
.de FN
.fi
.KE
.LP
..
.de IN		\" send an index entry to the stderr
..
.de C{
.KS
.nf
.D
.\"
.\"	choose appropriate monospace font
.\"	the imagen conditional, 480,
.\"	may be changed to L if LB is too
.\"	heavy for your eyes...
.\"
.ie "\\*(.T"480" .ft L
.el .ie "\\*(.T"300" .ft L
.el .ie "\\*(.T"202" .ft PO
.el .ie "\\*(.T"aps" .ft CW
.el .ft R
.ps \\n(PS
.ie \\n(VS>40 .vs \\n(VSu
.el .vs \\n(VSp
..
.de C}
.DE
.R
..
.de Pn
.ie t \\$1\fB\^\\$2\^\fR\\$3
.el \\$1\fI\^\\$2\^\fP\\$3
..
.de ZN
.ie t \fB\^\\$1\^\fR\\$2
.el \fI\^\\$1\^\fP\\$2
..
.de NT
.ne 7
.ds NO Note
.if \\n(.$>$1 .if !'\\$2'C' .ds NO \\$2
.if \\n(.$ .if !'\\$1'C' .ds NO \\$1
.ie n .sp
.el .sp 10p
.TB
.ce
\\*(NO
.ie n .sp
.el .sp 5p
.if '\\$1'C' .ce 99
.if '\\$2'C' .ce 99
.in +5n
.ll -5n
.R
..
.		\" Note End -- doug kraft 3/85
.de NE
.ce 0
.in -5n
.ll +5n
.ie n .sp
.el .sp 10p
..
.ny0
.TH XChangePointerControl 3X11 "Release 5" "X Version 11" "XLIB FUNCTIONS"
.SH NAME
XChangePointerControl, XGetPointerControl \- control pointer 
.SH SYNTAX
.\" $Header: XChPointCon.f,v 1.1 88/02/26 09:58:33 mento Exp $
XChangePointerControl\^(\^\fIdisplay\fP, \fIdo_accel\fP\^, \fIdo_threshold\fP\^, \fIaccel_numerator\fP\^, 
.br
                        \fIaccel_denominator\fP\^, \fIthreshold\fP\^)
.br
      Display *\fIdisplay\fP\^;
.br
      Bool \fIdo_accel\fP\^, \fIdo_threshold\fP\^;
.br
      int \fIaccel_numerator\fP\^, \fIaccel_denominator\fP\^;
.br
      int \fIthreshold\fP\^;
.LP
.\" $Header: XGetPntrCnt.f,v 1.1 88/02/26 10:00:55 mento Exp $
XGetPointerControl\^(\^\fIdisplay\fP, \fIaccel_numerator_return\fP\^, \fIaccel_denominator_return\fP\^, 
.br
                       \fIthreshold_return\fP\^)
.br
      Display *\fIdisplay\fP\^;
.br
      int *\fIaccel_numerator_return\fP\^, *\fIaccel_denominator_return\fP\^;
.br
      int *\fIthreshold_return\fP\^;
.SH ARGUMENTS
.\" $Header: acceldenom.a,v 1.1 88/02/26 10:04:37 mento Exp $
.IP \fIaccel_denominator\fP 1i
Specifies the denominator for the acceleration multiplier.
.\" $Header: acceldenomrt.a,v 1.1 88/02/26 10:04:37 mento Exp $
.IP \fIaccel_denominator_return\fP 1i
Returns the denominator for the acceleration multiplier.
.\" $Header: accelnum.a,v 1.1 88/02/26 10:04:44 mento Exp $
.IP \fIaccel_numerator\fP 1i
Specifies the numerator for the acceleration multiplier.
.\" $Header: accelnumret.a,v 1.1 88/02/26 10:04:45 mento Exp $
.IP \fIaccel_numerator_return\fP 1i
Returns the numerator for the acceleration multiplier.
.\" $Header: display.a,v 1.1 88/02/26 10:26:29 mento Exp $
.IP \fIdisplay\fP 1i
Specifies the connection to the X server.
.\" $Header: doaccel.a,v 1.4 88/05/14 09:22:57 mento Exp $
.IP \fIdo_accel\fP 1i
Specifies a Boolean value that controls whether the values for 
the accel_numerator or accel_denominator are used.
.\" $Header: dothreshold.a,v 1.5 88/05/14 09:24:07 mento Exp $
.IP \fIdo_threshold\fP 1i
Specifies a Boolean value that controls whether the value for the 
threshold is used.
.\" $Header: threshold.a,v 1.1 88/02/26 10:31:38 mento Exp $
.IP \fIthreshold\fP 1i
Specifies the acceleration threshold.
.\" $Header: thresholdret.a,v 1.1 88/02/26 10:31:39 mento Exp $
.IP \fIthreshold_return\fP 1i
Returns the acceleration threshold.
.SH DESCRIPTION
.\" $Header: XChPointCon.d,v 1.2 88/06/11 07:49:03 mento Exp $
The
.ZN XChangePointerControl
function defines how the pointing device moves.
The acceleration, expressed as a fraction, is a
multiplier for movement. 
For example,
specifying 3/1 means the pointer moves three times as fast as normal.
The fraction may be rounded arbitrarily by the X server.  
Acceleration
only takes effect if the pointer moves more than threshold pixels at
once and only applies to the amount beyond the value in the threshold argument.
Setting a value to \-1 restores the default.
The values of the do_accel and do_threshold arguments must be 
.ZN True 
for the pointer values to be set,
or the parameters are unchanged.
Negative values (other than \-1) generate a
.ZN BadValue
error, as does a zero value
for the accel_denominator argument.
.LP
.ZN XChangePointerControl
can generate a
.ZN BadValue 
error.
.LP
.\" $Header: XGetPntrCnt.d,v 1.1 88/02/26 10:48:32 mento Exp $
The
.ZN XGetPointerControl
function returns the pointer's current acceleration multiplier
and acceleration threshold.
.SH DIAGNOSTICS
.\" $Header: badvalue.e,v 1.1 87/09/04 08:23:19 mento Exp $
.TP 1i
.ZN BadValue
Some numeric value falls outside the range of values accepted by the request.
Unless a specific range is specified for an argument, the full range defined
by the argument's type is accepted.  Any argument defined as a set of
alternatives can generate this error.
.SH "SEE ALSO"
\fI\*(xL\fP
