.ds xT X Toolkit Intrinsics \- C Language Interface
.ds xW Athena X Widgets \- C Language X Toolkit Interface
.ds xL Xlib \- C Language X Interface
.ds xC Inter-Client Communication Conventions Manual
.na
.de Ds
.nf
.\\$1D \\$2 \\$1
.ft 1
.\".ps \\n(PS
.\".if \\n(VS>=40 .vs \\n(VSu
.\".if \\n(VS<=39 .vs \\n(VSp
..
.de De
.ce 0
.if \\n(BD .DF
.nr BD 0
.in \\n(OIu
.if \\n(TM .ls 2
.sp \\n(DDu
.fi
..
.de FD
.LP
.KS
.TA .5i 3i
.ta .5i 3i
.nf
..
.de FN
.fi
.KE
.LP
..
.de IN		\" send an index entry to the stderr
..
.de C{
.KS
.nf
.D
.\"
.\"	choose appropriate monospace font
.\"	the imagen conditional, 480,
.\"	may be changed to L if LB is too
.\"	heavy for your eyes...
.\"
.ie "\\*(.T"480" .ft L
.el .ie "\\*(.T"300" .ft L
.el .ie "\\*(.T"202" .ft PO
.el .ie "\\*(.T"aps" .ft CW
.el .ft R
.ps \\n(PS
.ie \\n(VS>40 .vs \\n(VSu
.el .vs \\n(VSp
..
.de C}
.DE
.R
..
.de Pn
.ie t \\$1\fB\^\\$2\^\fR\\$3
.el \\$1\fI\^\\$2\^\fP\\$3
..
.de ZN
.ie t \fB\^\\$1\^\fR\\$2
.el \fI\^\\$1\^\fP\\$2
..
.de NT
.ne 7
.ds NO Note
.if \\n(.$>$1 .if !'\\$2'C' .ds NO \\$2
.if \\n(.$ .if !'\\$1'C' .ds NO \\$1
.ie n .sp
.el .sp 10p
.TB
.ce
\\*(NO
.ie n .sp
.el .sp 5p
.if '\\$1'C' .ce 99
.if '\\$2'C' .ce 99
.in +5n
.ll -5n
.R
..
.		\" Note End -- doug kraft 3/85
.de NE
.ce 0
.in -5n
.ll +5n
.ie n .sp
.el .sp 10p
..
.ny0
.TH XFontsOfFontSet 3X11 "Release 5" "X Version 11" "XLIB FUNCTIONS"
.SH NAME
XFontsOfFontSet, XBaseFontNameListOfFontSet, XLocaleOfFontSet, XContextDependentDrawing \- obtain fontset information
.SH SYNTAX
int XFontsOfFontSet\^(\^\fIfont_set\fP\^, \fIfont_struct_list_return\fP\^, \fIfont_name_list_return\fP\^)
.br
       XFontSet \fIfont_set\fP\^;
.br
       XFontStruct ***\fIfont_struct_list_return\fP\^;
.br
       char ***\fIfont_name_list_return\fP\^;
.LP
char *XBaseFontNameListOfFontSet\^(\^\fIfont_set\fP\^)
.br
      XFontSet \fIfont_set\fP\^;
.LP
char *XLocaleOfFontSet\^(\^\fIfont_set\fP\^)
.br
      XFontSet \fIfont_set\fP\^;
.LP
Bool XContextDependentDrawing\^(\^\fIfont_set\fP\^)
.br
      XFontSet \fIfont_set\fP\^;
.SH ARGUMENTS
.\" $Header: fontset.a,v 1.2 88/05/09 14:28:06 mento Exp $
.IP \fIfont_set\fP 1i
Specifies the font set.
.IP \fIfont_name_list_return\fP 1i
Returns the list of font names.
.IP \fIfont_struct_list_return\fP 1i
Returns the list of font structs.
.SH DESCRIPTION
The
.ZN XFontsOfFontSet
function returns a list of one or more 
.ZN XFontStructs
and font names for the fonts used by the Xmb and Xwc layers,
for the given font set.
A list of pointers to the
.ZN XFontStruct
structures is returned to font_struct_list_return.
A list of pointers to null-terminated fully specified font name strings
in the locale of the font set is returned to font_name_list_return.
The font_name_list order corresponds to the font_struct_list order.
The number of
.ZN XFontStruct
structures and font names is returned as the value of the function.
.LP
Because it is not guaranteed that a given character will be imaged using a
single font glyph,
there is no provision for mapping a character or default string 
to the font properties, font ID, or direction hint for the font 
for the character.
The client may access the 
.ZN XFontStruct
list to obtain these values for all the fonts currently in use.
.LP
It is not required that fonts be loaded from the server at the creation of an 
.ZN XFontSet .
Xlib may choose to cache font data, loading it only as needed to draw text 
or compute text dimensions.
Therefore, existence of the per_char metrics in the 
.ZN XFontStruct
structures in the
.ZN XFontStructSet
is undefined.
Also, note that all properties in the 
.ZN XFontStruct
structures are in the STRING encoding.
.LP
The 
.ZN XFontStruct
and font name lists are owned by Xlib 
and should not be modified or freed by the client.
They will be freed by a call to
.ZN XFreeFontSet
with the associated
.ZN XFontSet .
Until freed, its contents will not be modified by Xlib.
.LP
The
.ZN XBaseFontNameListOfFontSet
function returns the original base font name list supplied
by the client when the 
.ZN XFontSet
was created.
A null-terminated string containing a list of
comma-separated font names is returned
as the value of the function.
Whitespace may appear immediately on either side of separating commas.
.LP
If 
.ZN XCreateFontSet
obtained an XLFD name from the font properties for the font specified
by a non-XLFD base name, the
.ZN XBaseFontNameListOfFontSet
function will return the XLFD name instead of the non-XLFD base name.
.LP
The base font name list is owned by Xlib and should not be modified or
freed by the client.
It will be freed by a call to 
.ZN XFreeFontSet
with the associated 
.ZN XFontSet .
Until freed, its contents will not be modified by Xlib.
.LP
The
.ZN XLocaleOfFontSet
function
returns the name of the locale bound to the specified
.ZN XFontSet ,
as a null-terminated string.
.LP
The returned locale name string is owned by Xlib
and should not be modified or freed by the client.
It may be freed by a call to
.ZN XFreeFontSet
with the associated 
.ZN XFontSet .
Until freed, it will not be modified by Xlib.
.LP
The
.ZN XContextDependentDrawing
function returns
.ZN True
if text drawn with the font_set might include context-dependent drawing.
.SH "SEE ALSO"
XCreateFontSet(3X11),
XExtentsOfFontSet(3X11),
XFontSetExtents(3X11)
.br
\fI\*(xL\fP
