.ds xT X Toolkit Intrinsics \- C Language Interface
.ds xW Athena X Widgets \- C Language X Toolkit Interface
.ds xL Xlib \- C Language X Interface
.ds xC Inter-Client Communication Conventions Manual
.na
.de Ds
.nf
.\\$1D \\$2 \\$1
.ft 1
.\".ps \\n(PS
.\".if \\n(VS>=40 .vs \\n(VSu
.\".if \\n(VS<=39 .vs \\n(VSp
..
.de De
.ce 0
.if \\n(BD .DF
.nr BD 0
.in \\n(OIu
.if \\n(TM .ls 2
.sp \\n(DDu
.fi
..
.de FD
.LP
.KS
.TA .5i 3i
.ta .5i 3i
.nf
..
.de FN
.fi
.KE
.LP
..
.de IN		\" send an index entry to the stderr
..
.de C{
.KS
.nf
.D
.\"
.\"	choose appropriate monospace font
.\"	the imagen conditional, 480,
.\"	may be changed to L if LB is too
.\"	heavy for your eyes...
.\"
.ie "\\*(.T"480" .ft L
.el .ie "\\*(.T"300" .ft L
.el .ie "\\*(.T"202" .ft PO
.el .ie "\\*(.T"aps" .ft CW
.el .ft R
.ps \\n(PS
.ie \\n(VS>40 .vs \\n(VSu
.el .vs \\n(VSp
..
.de C}
.DE
.R
..
.de Pn
.ie t \\$1\fB\^\\$2\^\fR\\$3
.el \\$1\fI\^\\$2\^\fP\\$3
..
.de ZN
.ie t \fB\^\\$1\^\fR\\$2
.el \fI\^\\$1\^\fP\\$2
..
.de NT
.ne 7
.ds NO Note
.if \\n(.$>$1 .if !'\\$2'C' .ds NO \\$2
.if \\n(.$ .if !'\\$1'C' .ds NO \\$1
.ie n .sp
.el .sp 10p
.TB
.ce
\\*(NO
.ie n .sp
.el .sp 5p
.if '\\$1'C' .ce 99
.if '\\$2'C' .ce 99
.in +5n
.ll -5n
.R
..
.		\" Note End -- doug kraft 3/85
.de NE
.ce 0
.in -5n
.ll +5n
.ie n .sp
.el .sp 10p
..
.ny0
.TH XrmMergeDatabases 3X11 "Release 5" "X Version 11" "XLIB FUNCTIONS"
.SH NAME
XrmMergeDatabases, XrmCombineDatabase, XrmCombineFileDatabase \- merge resource databases
.SH SYNTAX
void XrmMergeDatabases(\^\fIsource_db\fP, \fItarget_db\fP\^)
.br
      XrmDatabase \fIsource_db\fP, *\fItarget_db\fP\^;
.LP
void XrmCombineDatabase(\^\fIsource_db\fP, \fItarget_db\fP, \fIoverride\fP\^)
.br
      XrmDatabase \fIsource_db\fP, *\fItarget_db\fP\^;
.br
      Bool \fIoverride\fP;
.LP
void XrmCombineFileDatabase(\^\fIfilename\fP, \fItarget_db\fP, \fIoverride\fP\^)
.br
      char *\fIfilename\fP;
.br
      XrmDatabase *\fItarget_db\fP\^;
.br
      Bool \fIoverride\fP;
.SH ARGUMENTS
.IP \fIsource_db\fP 1i
Specifies the resource database that is to be merged into the target database.
.IP \fItarget_db\fP 1i
Specifies the resource database into which the source 
database is to be merged.
.IP \fIfilename\fP 1i
Specifies the resource database file name.
.SH DESCRIPTION
.\" $Header: XrmMDBase.d,v 1.2 88/06/11 07:54:46 mento Exp $
The
.ZN XrmMergeDatabases
function merges the contents of one database into another.
If the same specifier is used for an entry in both databases,
the entry in the source_db will replace the entry in the target_db
(that is, it overrides target_db).
If target_db contains NULL,
.ZN XrmMergeDatabases
simply stores source_db in it.
Otherwise, source_db is destroyed by the merge, but the database pointed
to by target_db is not destroyed.
The database entries are merged without changing values or types,
regardless of the locales of the databases.
The locale of the target database is not modified.
.LP
.\" $Header: XrmCDBase.d,v 1.2 88/06/11 07:54:46 mento Exp $
The
.ZN XrmCombineDatabase
function merges the contents of one database into another.
If the same specifier is used for an entry in both databases,
the entry in the source_db will replace the entry in the target_db
if override is
.ZN True ;
otherwise, the entry in source_db is discarded.
If target_db contains NULL,
.ZN XrmCombineDatabase
simply stores source_db in it.
Otherwise, source_db is destroyed by the merge, but the database pointed
to by target_db is not destroyed.
The database entries are merged without changing values or types,
regardless of the locales of the databases.
The locale of the target database is not modified.
.LP
.\" $Header: XrmCFDBase.d,v 1.2 88/06/11 07:54:46 mento Exp $
The
.ZN XrmCombineFileDatabase
function merges the contents of a resource file into a database.
If the same specifier is used for an entry in both the file and
the database,
the entry in the file will replace the entry in the database
if override is
.ZN True ;
otherwise, the entry in file is discarded.
The file is parsed in the current locale.
If the file cannot be read a zero status is returned;
otherwise a nonzero status is returned.
If target_db contains NULL,
.ZN XrmCombineFileDatabase
creates and returns a new database to it.
Otherwise, the database pointed to by target_db is not destroyed by the merge.
The database entries are merged without changing values or types,
regardless of the locale of the database.
The locale of the target database is not modified.
.SH "SEE ALSO"
XrmGetResource(3X11),
XrmInitialize(3X11),
XrmPutResource(3X11)
.br
\fI\*(xL\fP
