.ds xT X Toolkit Intrinsics \- C Language Interface
.ds xW Athena X Widgets \- C Language X Toolkit Interface
.ds xL Xlib \- C Language X Interface
.ds xC Inter-Client Communication Conventions Manual
.na
.de Ds
.nf
.\\$1D \\$2 \\$1
.ft 1
.\".ps \\n(PS
.\".if \\n(VS>=40 .vs \\n(VSu
.\".if \\n(VS<=39 .vs \\n(VSp
..
.de De
.ce 0
.if \\n(BD .DF
.nr BD 0
.in \\n(OIu
.if \\n(TM .ls 2
.sp \\n(DDu
.fi
..
.de FD
.LP
.KS
.TA .5i 3i
.ta .5i 3i
.nf
..
.de FN
.fi
.KE
.LP
..
.de IN		\" send an index entry to the stderr
..
.de C{
.KS
.nf
.D
.\"
.\"	choose appropriate monospace font
.\"	the imagen conditional, 480,
.\"	may be changed to L if LB is too
.\"	heavy for your eyes...
.\"
.ie "\\*(.T"480" .ft L
.el .ie "\\*(.T"300" .ft L
.el .ie "\\*(.T"202" .ft PO
.el .ie "\\*(.T"aps" .ft CW
.el .ft R
.ps \\n(PS
.ie \\n(VS>40 .vs \\n(VSu
.el .vs \\n(VSp
..
.de C}
.DE
.R
..
.de Pn
.ie t \\$1\fB\^\\$2\^\fR\\$3
.el \\$1\fI\^\\$2\^\fP\\$3
..
.de ZN
.ie t \fB\^\\$1\^\fR\\$2
.el \fI\^\\$1\^\fP\\$2
..
.de NT
.ne 7
.ds NO Note
.if \\n(.$>$1 .if !'\\$2'C' .ds NO \\$2
.if \\n(.$ .if !'\\$1'C' .ds NO \\$1
.ie n .sp
.el .sp 10p
.TB
.ce
\\*(NO
.ie n .sp
.el .sp 5p
.if '\\$1'C' .ce 99
.if '\\$2'C' .ce 99
.in +5n
.ll -5n
.R
..
.		\" Note End -- doug kraft 3/85
.de NE
.ce 0
.in -5n
.ll +5n
.ie n .sp
.el .sp 10p
..
.ny0
.TH XQueryBestSize 3X11 "Release 5" "X Version 11" "XLIB FUNCTIONS"
.SH NAME
XQueryBestSize, XQueryBestTile, XQueryBestStipple \- determine efficient sizes
.SH SYNTAX
Status XQueryBestSize\^(\^\fIdisplay\fP, \fIclass\fP, \fIwhich_screen\fP, \fIwidth\fP, \fIheight\fP, \fIwidth_return\fP, \fIheight_return\fP\^) 
.br
      Display *\fIdisplay\fP\^;
.br
      int \fIclass\fP\^;
.br
      Drawable \fIwhich_screen\fP\^;
.br
      unsigned int \fIwidth\fP, \fIheight\fP\^;
.br
      unsigned int *\fIwidth_return\fP, *\fIheight_return\fP\^;
.LP
Status XQueryBestTile\^(\^\fIdisplay\fP, \fIwhich_screen\fP, \fIwidth\fP, \fIheight\fP, \fIwidth_return\fP, \fIheight_return\fP\^) 
.br
      Display *\fIdisplay\fP\^;
.br
      Drawable \fIwhich_screen\fP\^;
.br
      unsigned int \fIwidth\fP, \fIheight\fP\^;
.br
      unsigned int *\fIwidth_return\fP, *\fIheight_return\fP\^;
.LP
Status XQueryBestStipple\^(\^\fIdisplay\fP, \fIwhich_screen\fP, \fIwidth\fP, \fIheight\fP, \fIwidth_return\fP, \fIheight_return\fP\^) 
.br
      Display *\fIdisplay\fP\^;
.br
      Drawable \fIwhich_screen\fP\^;
.br
      unsigned int \fIwidth\fP, \fIheight\fP\^;
.br
      unsigned int *\fIwidth_return\fP, *\fIheight_return\fP\^;
.SH ARGUMENTS
.IP \fIclass\fP 1i
Specifies the class that you are interested in.
You can pass 
.ZN TileShape , 
.ZN CursorShape , 
or 
.ZN StippleShape .
.\" $Header: display.a,v 1.1 88/02/26 10:26:29 mento Exp $
.IP \fIdisplay\fP 1i
Specifies the connection to the X server.
.\" $Header: widtheight.a,v 1.1 88/02/26 10:32:27 mento Exp $
.IP \fIwidth\fP 1i
.br
.ns
.IP \fIheight\fP 1i
Specify the width and height.
.IP \fIwhich_screen\fP 1i
Specifies any drawable on the screen.
.\" $Header: rwidtheight.a,v 1.2 88/05/09 11:58:59 mento Exp $
.IP \fIwidth_return\fP 1i
.br
.ns
.IP \fIheight_return\fP 1i
Return the width and height of the object best supported 
by the display hardware.
.SH DESCRIPTION
.\" $Header: XQBestSize.d,v 1.2 88/06/11 07:52:31 mento Exp $
The
.ZN XQueryBestSize
function returns the best or closest size to the specified size.
For 
.ZN CursorShape ,
this is the largest size that can be fully displayed on the screen specified by
which_screen.
For 
.ZN TileShape ,
this is the size that can be tiled fastest.
For 
.ZN StippleShape ,
this is the size that can be stippled fastest.
For 
.ZN CursorShape ,
the drawable indicates the desired screen.
For 
.ZN TileShape 
and 
.ZN StippleShape ,
the drawable indicates the screen and possibly the window class and depth.
An 
.ZN InputOnly 
window cannot be used as the drawable for 
.ZN TileShape
or 
.ZN StippleShape ,
or a
.ZN BadMatch 
error results.
.LP
.ZN XQueryBestSize
can generate
.ZN BadDrawable ,
.ZN BadMatch ,
and
.ZN BadValue 
errors.
.LP
.\" $Header: XQTileShp.d,v 1.2 88/06/11 07:52:32 mento Exp $
The
.ZN XQueryBestTile
function returns the best or closest size, that is, the size that can be
tiled fastest on the screen specified by which_screen.
The drawable indicates the screen and possibly the window class and depth.
If an 
.ZN InputOnly 
window is used as the drawable, a 
.ZN BadMatch 
error results.
.LP
.ZN XQueryBestTile
can generate
.ZN BadDrawable
and
.ZN BadMatch 
errors.
.LP
.\" $Header: XQStipShp.d,v 1.2 88/06/11 07:52:31 mento Exp $
The
.ZN XQueryBestStipple
function returns the best or closest size, that is, the size that can be
stippled fastest on the screen specified by which_screen.
The drawable indicates the screen and possibly the window class and depth.
If an
.ZN InputOnly
window is used as the drawable, a
.ZN BadMatch
error results.
.LP
.ZN XQueryBestStipple
can generate
.ZN BadDrawable
and
.ZN BadMatch 
errors.
.SH DIAGNOSTICS
.\" $Header: badmatch1.e,v 1.3 87/09/09 18:18:54 mento Exp $
.TP 1i
.ZN BadMatch
An
.ZN InputOnly
window is used as a Drawable.
.\" $Header: baddrawable.e,v 1.1 87/09/04 08:22:59 mento Exp $
.TP 1i
.ZN BadDrawable
A value for a Drawable argument does not name a defined Window or Pixmap.
.\" $Header: badmatch4.e,v 1.2 87/09/11 11:43:34 mento Exp $
.TP 1i
.ZN BadMatch
The values do not exist for an
.ZN InputOnly
window.
.\" $Header: badvalue.e,v 1.1 87/09/04 08:23:19 mento Exp $
.TP 1i
.ZN BadValue
Some numeric value falls outside the range of values accepted by the request.
Unless a specific range is specified for an argument, the full range defined
by the argument's type is accepted.  Any argument defined as a set of
alternatives can generate this error.
.SH "SEE ALSO"
XCreateGC(3X11),
XSetArcMode(3X11),
XSetClipOrigin(3X11),
XSetFillStyle(3X11),
XSetFont(3X11),
XSetLineAttributes(3X11),
XSetState(3X11),
XSetTile(3X11)
.br
\fI\*(xL\fP
