.ds xT X Toolkit Intrinsics \- C Language Interface
.ds xW Athena X Widgets \- C Language X Toolkit Interface
.ds xL Xlib \- C Language X Interface
.ds xC Inter-Client Communication Conventions Manual
.na
.de Ds
.nf
.\\$1D \\$2 \\$1
.ft 1
.\".ps \\n(PS
.\".if \\n(VS>=40 .vs \\n(VSu
.\".if \\n(VS<=39 .vs \\n(VSp
..
.de De
.ce 0
.if \\n(BD .DF
.nr BD 0
.in \\n(OIu
.if \\n(TM .ls 2
.sp \\n(DDu
.fi
..
.de FD
.LP
.KS
.TA .5i 3i
.ta .5i 3i
.nf
..
.de FN
.fi
.KE
.LP
..
.de IN		\" send an index entry to the stderr
..
.de C{
.KS
.nf
.D
.\"
.\"	choose appropriate monospace font
.\"	the imagen conditional, 480,
.\"	may be changed to L if LB is too
.\"	heavy for your eyes...
.\"
.ie "\\*(.T"480" .ft L
.el .ie "\\*(.T"300" .ft L
.el .ie "\\*(.T"202" .ft PO
.el .ie "\\*(.T"aps" .ft CW
.el .ft R
.ps \\n(PS
.ie \\n(VS>40 .vs \\n(VSu
.el .vs \\n(VSp
..
.de C}
.DE
.R
..
.de Pn
.ie t \\$1\fB\^\\$2\^\fR\\$3
.el \\$1\fI\^\\$2\^\fP\\$3
..
.de ZN
.ie t \fB\^\\$1\^\fR\\$2
.el \fI\^\\$1\^\fP\\$2
..
.de NT
.ne 7
.ds NO Note
.if \\n(.$>$1 .if !'\\$2'C' .ds NO \\$2
.if \\n(.$ .if !'\\$1'C' .ds NO \\$1
.ie n .sp
.el .sp 10p
.TB
.ce
\\*(NO
.ie n .sp
.el .sp 5p
.if '\\$1'C' .ce 99
.if '\\$2'C' .ce 99
.in +5n
.ll -5n
.R
..
.		\" Note End -- doug kraft 3/85
.de NE
.ce 0
.in -5n
.ll +5n
.ie n .sp
.el .sp 10p
..
.ny0
.TH XResourceManagerString 3X11 "Release 5" "X Version 11" "XLIB FUNCTIONS"
.SH NAME
XResourceManagerString, XScreenResourceString \- obtain server resource properties
.SH SYNTAX
char *XResourceManagerString\^(\^\fIdisplay\fP\^)
.br
      Display *\fIdisplay\fP\^;
.LP
char *XScreenResourceString\^(\^\fIscreen\fP\^)
.br
      Screen *\fIscreen\fP\^;
.SH ARGUMENTS
.\" $Header: display.a,v 1.1 88/02/26 10:26:29 mento Exp $
.IP \fIdisplay\fP 1i
Specifies the connection to the X server.
.IP \fIscreen\fP 1i
Specifies the screen.
.SH DESCRIPTION
The
.ZN XResourceManagerString
returns the RESOURCE_MANAGER property from the server's root window of screen
zero, which was returned when the connection was opened using
.ZN XOpenDisplay .
The property is converted from type STRING to the current locale.
The conversion is identical to that produced by 
.ZN XmbTextPropertyToTextList
for a singleton STRING property.
The returned string is owned by Xlib, and should not be freed by the client.
Note that the property value must be in a format that is acceptable to
.ZN XrmGetStringDatabase .
If no property exists, NULL is returned.
.LP
The
.ZN XStringResourceString
returns the SCREEN_RESOURCES property from the root window of the
specified screen.
The property is converted from type STRING to the current locale.
The conversion is identical to that produced by 
.ZN XmbTextPropertyToTextList
for a singleton STRING property.
Note that the property value must be in a format that is acceptable to
.ZN XrmGetStringDatabase .
If no property exists, NULL is returned.
The caller is responsible for freeing the returned string, using
.ZN XFree .
.SH "SEE ALSO"
\fI\*(xL\fP
