.ds xT X Toolkit Intrinsics \- C Language Interface
.ds xW Athena X Widgets \- C Language X Toolkit Interface
.ds xL Xlib \- C Language X Interface
.ds xC Inter-Client Communication Conventions Manual
.na
.de Ds
.nf
.\\$1D \\$2 \\$1
.ft 1
.\".ps \\n(PS
.\".if \\n(VS>=40 .vs \\n(VSu
.\".if \\n(VS<=39 .vs \\n(VSp
..
.de De
.ce 0
.if \\n(BD .DF
.nr BD 0
.in \\n(OIu
.if \\n(TM .ls 2
.sp \\n(DDu
.fi
..
.de FD
.LP
.KS
.TA .5i 3i
.ta .5i 3i
.nf
..
.de FN
.fi
.KE
.LP
..
.de IN		\" send an index entry to the stderr
..
.de C{
.KS
.nf
.D
.\"
.\"	choose appropriate monospace font
.\"	the imagen conditional, 480,
.\"	may be changed to L if LB is too
.\"	heavy for your eyes...
.\"
.ie "\\*(.T"480" .ft L
.el .ie "\\*(.T"300" .ft L
.el .ie "\\*(.T"202" .ft PO
.el .ie "\\*(.T"aps" .ft CW
.el .ft R
.ps \\n(PS
.ie \\n(VS>40 .vs \\n(VSu
.el .vs \\n(VSp
..
.de C}
.DE
.R
..
.de Pn
.ie t \\$1\fB\^\\$2\^\fR\\$3
.el \\$1\fI\^\\$2\^\fP\\$3
..
.de ZN
.ie t \fB\^\\$1\^\fR\\$2
.el \fI\^\\$1\^\fP\\$2
..
.de NT
.ne 7
.ds NO Note
.if \\n(.$>$1 .if !'\\$2'C' .ds NO \\$2
.if \\n(.$ .if !'\\$1'C' .ds NO \\$1
.ie n .sp
.el .sp 10p
.TB
.ce
\\*(NO
.ie n .sp
.el .sp 5p
.if '\\$1'C' .ce 99
.if '\\$2'C' .ce 99
.in +5n
.ll -5n
.R
..
.		\" Note End -- doug kraft 3/85
.de NE
.ce 0
.in -5n
.ll +5n
.ie n .sp
.el .sp 10p
..
.ny0
.TH XSetArcMode 3X11 "Release 5" "X Version 11" "XLIB FUNCTIONS"
.SH NAME
XSetArcMode, XSetSubwindowMode, XSetGraphicsExposure \- GC convenience routines
.SH SYNTAX
.\" $Header: XSetArcMode.f,v 1.1 88/02/26 10:02:54 mento Exp $
XSetArcMode\^(\^\fIdisplay\fP, \fIgc\fP\^, \fIarc_mode\fP\^)
.br
      Display *\fIdisplay\fP\^;
.br
      GC \fIgc\fP\^;
.br
      int \fIarc_mode\fP\^;
.LP
.\" $Header: XSetSubMode.f,v 1.1 88/02/26 10:03:40 mento Exp $
XSetSubwindowMode\^(\^\fIdisplay\fP, \fIgc\fP\^, \fIsubwindow_mode\fP\^)
.br
      Display *\fIdisplay\fP\^;
.br
      GC \fIgc\fP\^;
.br
      int \fIsubwindow_mode\fP\^;
.LP
.\" $Header: XSetGrExp.f,v 1.2 88/04/04 11:02:37 mento Exp $
XSetGraphicsExposures\^(\^\fIdisplay\fP, \fIgc\fP\^, \fIgraphics_exposures\fP\^)
.br
      Display *\fIdisplay\fP\^;
.br
      GC \fIgc\fP\^;
.br
      Bool \fIgraphics_exposures\fP\^;
.SH ARGUMENTS
.\" $Header: arc_mode.a,v 1.2 88/05/09 12:21:20 mento Exp $
.IP \fIarc_mode\fP 1i
Specifies the arc mode.
You can pass
.ZN ArcChord
or
.ZN ArcPieSlice .
.\" $Header: display.a,v 1.1 88/02/26 10:26:29 mento Exp $
.IP \fIdisplay\fP 1i
Specifies the connection to the X server.
.\" $Header: gc.a,v 1.2 88/05/09 11:20:34 mento Exp $
.IP \fIgc\fP 1i
Specifies the GC.
.\" $Header: graph_exp.a,v 1.4 88/08/18 08:13:37 mento Exp $
.IP \fIgraphics_exposures\fP 1i
Specifies a Boolean value that indicates whether you want
.ZN GraphicsExpose
and
.ZN NoExpose
events to be reported when calling
.ZN XCopyArea
and
.ZN XCopyPlane
with this GC.
.\" $Header: sub_mode.a,v 1.2 88/05/09 12:23:45 mento Exp $
.IP \fIsubwindow_mode\fP 1i
Specifies the subwindow mode.
You can pass
.ZN ClipByChildren
or
.ZN IncludeInferiors .
.SH DESCRIPTION
.\" $Header: XSetArcMode.d,v 1.2 88/06/11 07:53:00 mento Exp $
The
.ZN XSetArcMode
function sets the arc mode in the specified GC.
.LP
.ZN XSetArcMode
can generate
.ZN BadAlloc ,
.ZN BadGC ,
and
.ZN BadValue 
errors.
.LP
.\" $Header: XSetSubMode.d,v 1.2 88/06/11 07:53:35 mento Exp $
The
.ZN XSetSubwindowMode
function sets the subwindow mode in the specified GC.
.LP
.ZN XSetSubwindowMode
can generate
.ZN BadAlloc ,
.ZN BadGC ,
and
.ZN BadValue 
errors.
.LP
.\" $Header: XSetGrExp.d,v 1.2 88/06/11 07:53:14 mento Exp $
The
.ZN XSetGraphicsExposures
function sets the graphics-exposures flag in the specified GC.
.LP
.ZN XSetGraphicsExposures
can generate
.ZN BadAlloc ,
.ZN BadGC ,
and
.ZN BadValue 
errors.
.SH DIAGNOSTICS
.\" $Header: badalloc.e,v 1.3 87/09/11 11:17:14 mento Exp $
.TP 1i
.ZN BadAlloc
The server failed to allocate the requested resource or server memory.
.\" $Header: badgc.e,v 1.1 87/09/04 08:23:02 mento Locked $
.TP 1i
.ZN BadGC
A value for a GContext argument does not name a defined GContext.
.\" $Header: badvalue.e,v 1.1 87/09/04 08:23:19 mento Exp $
.TP 1i
.ZN BadValue
Some numeric value falls outside the range of values accepted by the request.
Unless a specific range is specified for an argument, the full range defined
by the argument's type is accepted.  Any argument defined as a set of
alternatives can generate this error.
.SH "SEE ALSO"
XCopyArea(3X11),
XCreateGC(3X11),
XQueryBestSize(3X11),
XSetClipOrigin(3X11),
XSetFillStyle(3X11),
XSetFont(3X11),
XSetLineAttributes(3X11),
XSetState(3X11),
XSetTile(3X11)
.br
\fI\*(xL\fP
