.ds xT X Toolkit Intrinsics \- C Language Interface
.ds xW Athena X Widgets \- C Language X Toolkit Interface
.ds xL Xlib \- C Language X Interface
.ds xC Inter-Client Communication Conventions Manual
.na
.de Ds
.nf
.\\$1D \\$2 \\$1
.ft 1
.\".ps \\n(PS
.\".if \\n(VS>=40 .vs \\n(VSu
.\".if \\n(VS<=39 .vs \\n(VSp
..
.de De
.ce 0
.if \\n(BD .DF
.nr BD 0
.in \\n(OIu
.if \\n(TM .ls 2
.sp \\n(DDu
.fi
..
.de FD
.LP
.KS
.TA .5i 3i
.ta .5i 3i
.nf
..
.de FN
.fi
.KE
.LP
..
.de IN		\" send an index entry to the stderr
..
.de C{
.KS
.nf
.D
.\"
.\"	choose appropriate monospace font
.\"	the imagen conditional, 480,
.\"	may be changed to L if LB is too
.\"	heavy for your eyes...
.\"
.ie "\\*(.T"480" .ft L
.el .ie "\\*(.T"300" .ft L
.el .ie "\\*(.T"202" .ft PO
.el .ie "\\*(.T"aps" .ft CW
.el .ft R
.ps \\n(PS
.ie \\n(VS>40 .vs \\n(VSu
.el .vs \\n(VSp
..
.de C}
.DE
.R
..
.de Pn
.ie t \\$1\fB\^\\$2\^\fR\\$3
.el \\$1\fI\^\\$2\^\fP\\$3
..
.de ZN
.ie t \fB\^\\$1\^\fR\\$2
.el \fI\^\\$1\^\fP\\$2
..
.de NT
.ne 7
.ds NO Note
.if \\n(.$>$1 .if !'\\$2'C' .ds NO \\$2
.if \\n(.$ .if !'\\$1'C' .ds NO \\$1
.ie n .sp
.el .sp 10p
.TB
.ce
\\*(NO
.ie n .sp
.el .sp 5p
.if '\\$1'C' .ce 99
.if '\\$2'C' .ce 99
.in +5n
.ll -5n
.R
..
.		\" Note End -- doug kraft 3/85
.de NE
.ce 0
.in -5n
.ll +5n
.ie n .sp
.el .sp 10p
..
.ny0
.TH XSetClipOrigin 3X11 "Release 5" "X Version 11" "XLIB FUNCTIONS"
.SH NAME
XSetClipOrigin, XSetClipMask, XSetClipRectangles \- GC convenience routines
.SH SYNTAX
.\" $Header: XSetClipOrig.f,v 1.1 88/02/26 10:02:57 mento Exp $
XSetClipOrigin\^(\^\fIdisplay\fP, \fIgc\fP\^, \fIclip_x_origin\fP\^, \fIclip_y_origin\fP\^)
.br
      Display *\fIdisplay\fP\^;
.br
      GC \fIgc\fP\^;
.br
      int \fIclip_x_origin\fP\^, \fIclip_y_origin\fP\^;
.LP
XSetClipMask\^(\^\fIdisplay\fP, \fIgc\fP, \fIpixmap\fP\^)
.br
      Display *\fIdisplay\fP\^;
.br
      GC \fIgc\fP\^;
.br
      Pixmap \fIpixmap\fP\^;
.LP
.\" $Header: XSetClpRects.f,v 1.1 88/02/26 10:02:59 mento Exp $
XSetClipRectangles\^(\^\fIdisplay\fP, \fIgc\fP\^, \fIclip_x_origin\fP\^, \fIclip_y_origin\fP\^, \fIrectangles\fP\^, \fIn\fP\^, \fIordering\fP\^)
.br
      Display *\fIdisplay\fP\^;
.br
      GC \fIgc\fP\^;
.br
      int \fIclip_x_origin\fP\^, \fIclip_y_origin\fP\^;
.br
      XRectangle \fIrectangles\fP[]\^;
.br
      int \fIn\fP\^;
.br
      int \fIordering\fP\^;
.SH ARGUMENTS
.\" $Header: display.a,v 1.1 88/02/26 10:26:29 mento Exp $
.IP \fIdisplay\fP 1i
Specifies the connection to the X server.
.\" $Header: clipxy.a,v 1.3 88/05/09 12:10:59 mento Exp $
.IP \fIclip_x_origin\fP 1i
.br
.ns
.IP \fIclip_y_origin\fP 1i
Specify the x and y coordinates of the clip-mask origin.
.\" $Header: gc.a,v 1.2 88/05/09 11:20:34 mento Exp $
.IP \fIgc\fP 1i
Specifies the GC.
.\" $Header: n2.a,v 1.1 88/02/26 10:29:03 mento Exp $
.IP \fIn\fP 1i
Specifies the number of rectangles. 
.\" $Header: ordering.a,v 1.2 88/05/09 12:17:14 mento Exp $
.IP \fIordering\fP 1i
Specifies the ordering relations on the rectangles.
You can pass
.ZN Unsorted ,
.ZN YSorted ,
.ZN YXSorted ,
or
.ZN YXBanded .
.IP \fIpixmap\fP 1i
Specifies the pixmap or
.ZN None .
.\" $Header: rectangles1.a,v 1.2 88/05/09 12:16:32 mento Exp $
.IP \fIrectangles\fP 1i
Specifies an array of rectangles that define the clip-mask.
.SH DESCRIPTION
.\" $Header: XSetClipOrig.d,v 1.2 88/06/11 07:53:02 mento Exp $
The
.ZN XSetClipOrigin
function sets the clip origin in the specified GC.
The clip-mask origin is interpreted relative to the origin of whatever
destination drawable is specified in the graphics request.
.LP
.ZN XSetClipOrigin
can generate
.ZN BadAlloc
and
.ZN BadGC 
errors.
.LP
.\" $Header: XSetClpMask.d,v 1.2 88/06/11 07:53:02 mento Exp $
The
.ZN XSetClipMask
function sets the clip-mask in the specified GC to the specified pixmap.
If the clip-mask is set to
.ZN None ,
the pixels are are always drawn (regardless of the clip-origin).
.LP
.ZN XSetClipMask
can generate
.ZN BadAlloc ,
.ZN BadGC ,
.ZN BadMatch ,
and
.ZN BadValue 
errors.
.LP
.\" $Header: XSetClpRects.d,v 1.3 88/06/11 07:53:03 mento Exp $
The
.ZN XSetClipRectangles
function changes the clip-mask in the specified GC 
to the specified list of rectangles and sets the clip origin.
The output is clipped to remain contained within the
rectangles.
The clip-origin is interpreted relative to the origin of
whatever destination drawable is specified in a graphics request.  
The rectangle coordinates are interpreted relative to the clip-origin.  
The rectangles should be nonintersecting, or the graphics results will be
undefined.
Note that the list of rectangles can be empty, 
which effectively disables output.
This is the opposite of passing
.ZN None
as the clip-mask in
.ZN XCreateGC ,
.ZN XChangeGC ,
and
.ZN XSetClipMask .
.LP
If known by the client, ordering relations on the rectangles can be
specified with the ordering argument. 
This may provide faster operation
by the server. 
If an incorrect ordering is specified, the X server may generate a
.ZN BadMatch
error, but it is not required to do so.
If no error is generated, the graphics
results are undefined.
.ZN Unsorted 
means the rectangles are in arbitrary order.
.ZN YSorted 
means that the rectangles are nondecreasing in their Y origin.
.ZN YXSorted 
additionally constrains 
.ZN YSorted 
order in that all
rectangles with an equal Y origin are nondecreasing in their X
origin.  
.ZN YXBanded 
additionally constrains 
.ZN YXSorted 
by requiring that,
for every possible Y scanline, all rectangles that include that
scanline have an identical Y origins and Y extents.
.LP
.ZN XSetClipRectangles
can generate
.ZN BadAlloc ,
.ZN BadGC ,
.ZN BadMatch ,
and
.ZN BadValue 
errors.
.SH DIAGNOSTICS
.\" $Header: badalloc.e,v 1.3 87/09/11 11:17:14 mento Exp $
.TP 1i
.ZN BadAlloc
The server failed to allocate the requested resource or server memory.
.\" $Header: badgc.e,v 1.1 87/09/04 08:23:02 mento Locked $
.TP 1i
.ZN BadGC
A value for a GContext argument does not name a defined GContext.
.\" $Header: badmatch2.e,v 1.3 87/09/11 11:53:42 mento Exp $
.TP 1i
.ZN BadMatch
Some argument or pair of arguments has the correct type and range but fails
to match in some other way required by the request.
.\" $Header: badvalue.e,v 1.1 87/09/04 08:23:19 mento Exp $
.TP 1i
.ZN BadValue
Some numeric value falls outside the range of values accepted by the request.
Unless a specific range is specified for an argument, the full range defined
by the argument's type is accepted.  Any argument defined as a set of
alternatives can generate this error.
.SH "SEE ALSO"
XCreateGC(3X11),
XDrawRectangle(3X11),
XQueryBestSize(3X11),
XSetArcMode(3X11),
XSetFillStyle(3X11),
XSetFont(3X11),
XSetLineAttributes(3X11),
XSetState(3X11),
XSetTile(3X11)
.br
\fI\*(xL\fP
