.ds xT X Toolkit Intrinsics \- C Language Interface
.ds xW Athena X Widgets \- C Language X Toolkit Interface
.ds xL Xlib \- C Language X Interface
.ds xC Inter-Client Communication Conventions Manual
.na
.de Ds
.nf
.\\$1D \\$2 \\$1
.ft 1
.\".ps \\n(PS
.\".if \\n(VS>=40 .vs \\n(VSu
.\".if \\n(VS<=39 .vs \\n(VSp
..
.de De
.ce 0
.if \\n(BD .DF
.nr BD 0
.in \\n(OIu
.if \\n(TM .ls 2
.sp \\n(DDu
.fi
..
.de FD
.LP
.KS
.TA .5i 3i
.ta .5i 3i
.nf
..
.de FN
.fi
.KE
.LP
..
.de IN		\" send an index entry to the stderr
..
.de C{
.KS
.nf
.D
.\"
.\"	choose appropriate monospace font
.\"	the imagen conditional, 480,
.\"	may be changed to L if LB is too
.\"	heavy for your eyes...
.\"
.ie "\\*(.T"480" .ft L
.el .ie "\\*(.T"300" .ft L
.el .ie "\\*(.T"202" .ft PO
.el .ie "\\*(.T"aps" .ft CW
.el .ft R
.ps \\n(PS
.ie \\n(VS>40 .vs \\n(VSu
.el .vs \\n(VSp
..
.de C}
.DE
.R
..
.de Pn
.ie t \\$1\fB\^\\$2\^\fR\\$3
.el \\$1\fI\^\\$2\^\fP\\$3
..
.de ZN
.ie t \fB\^\\$1\^\fR\\$2
.el \fI\^\\$1\^\fP\\$2
..
.de NT
.ne 7
.ds NO Note
.if \\n(.$>$1 .if !'\\$2'C' .ds NO \\$2
.if \\n(.$ .if !'\\$1'C' .ds NO \\$1
.ie n .sp
.el .sp 10p
.TB
.ce
\\*(NO
.ie n .sp
.el .sp 5p
.if '\\$1'C' .ce 99
.if '\\$2'C' .ce 99
.in +5n
.ll -5n
.R
..
.		\" Note End -- doug kraft 3/85
.de NE
.ce 0
.in -5n
.ll +5n
.ie n .sp
.el .sp 10p
..
.ny0
.TH XSetPointerMapping 3X11 "Release 5" "X Version 11" "XLIB FUNCTIONS"
.SH NAME
XSetPointerMapping, XGetPointerMapping \- manipulate pointer settings
.SH SYNTAX
int XSetPointerMapping\^(\^\fIdisplay\fP, \fImap\fP, \fInmap\fP\^)
.br
      Display *\fIdisplay\fP\^;
.br
      unsigned char \fImap\fP\^[]\^;
.br
      int \fInmap\fP\^;
.LP
int XGetPointerMapping\^(\^\fIdisplay\fP, \fImap_return\fP, \fInmap\fP\^)
.br
      Display *\fIdisplay\fP\^;
.br
      unsigned char \fImap_return\fP\^[]\^;
.br
      int \fInmap\fP\^;
.SH ARGUMENTS
.\" $Header: display.a,v 1.1 88/02/26 10:26:29 mento Exp $
.IP \fIdisplay\fP 1i
Specifies the connection to the X server.
.IP \fImap\fP 1i
Specifies the mapping list.
.IP \fImap_return\fP 1i
Returns the mapping list.
.IP \fInmap\fP 1i
Specifies the number of items in the mapping list.
.SH DESCRIPTION
.\" $Header: XSetPMap.d,v 1.3 88/06/11 07:53:27 mento Exp $
The
.ZN XSetPointerMapping
function sets the mapping of the pointer.
If it succeeds, the X server generates a
.ZN MappingNotify
event, and
.ZN XSetPointerMapping
returns
.ZN MappingSuccess .
Element map[i] defines the logical button number for the physical button
i+1.
The length of the list must be the same as
.ZN XGetPointerMapping
would return,
or a
.ZN BadValue
error results.
A zero element disables a button, and elements are not restricted in
value by the number of physical buttons.
However, no two elements can have the same nonzero value,
or a
.ZN BadValue
error results.
If any of the buttons to be altered are logically in the down state,
.ZN XSetPointerMapping
returns
.ZN MappingBusy ,
and the mapping is not changed.
.LP
.ZN XSetPointerMapping
can generate a
.ZN BadValue 
error.
.LP
.\" $Header: XGetPMap.d,v 1.2 88/06/11 07:51:13 mento Exp $
The
.ZN XGetPointerMapping
function returns the current mapping of the pointer.
Pointer buttons are numbered starting from one.
.ZN XGetPointerMapping
returns the number of physical buttons actually on the pointer.
The nominal mapping for a pointer is map[i]=i+1.
The nmap argument specifies the length of the array where the pointer
mapping is returned, and only the first nmap elements are returned 
in map_return.
.SH DIAGNOSTICS
.\" $Header: badvalue.e,v 1.1 87/09/04 08:23:19 mento Exp $
.TP 1i
.ZN BadValue
Some numeric value falls outside the range of values accepted by the request.
Unless a specific range is specified for an argument, the full range defined
by the argument's type is accepted.  Any argument defined as a set of
alternatives can generate this error.
.SH "SEE ALSO"
XChangeKeyboardControl(3X11),
XChangeKeyboardMapping(3X11)
.br
\fI\*(xL\fP
