.ds xT X Toolkit Intrinsics \- C Language Interface
.ds xW Athena X Widgets \- C Language X Toolkit Interface
.ds xL Xlib \- C Language X Interface
.ds xC Inter-Client Communication Conventions Manual
.na
.de Ds
.nf
.\\$1D \\$2 \\$1
.ft 1
.\".ps \\n(PS
.\".if \\n(VS>=40 .vs \\n(VSu
.\".if \\n(VS<=39 .vs \\n(VSp
..
.de De
.ce 0
.if \\n(BD .DF
.nr BD 0
.in \\n(OIu
.if \\n(TM .ls 2
.sp \\n(DDu
.fi
..
.de FD
.LP
.KS
.TA .5i 3i
.ta .5i 3i
.nf
..
.de FN
.fi
.KE
.LP
..
.de IN		\" send an index entry to the stderr
..
.de C{
.KS
.nf
.D
.\"
.\"	choose appropriate monospace font
.\"	the imagen conditional, 480,
.\"	may be changed to L if LB is too
.\"	heavy for your eyes...
.\"
.ie "\\*(.T"480" .ft L
.el .ie "\\*(.T"300" .ft L
.el .ie "\\*(.T"202" .ft PO
.el .ie "\\*(.T"aps" .ft CW
.el .ft R
.ps \\n(PS
.ie \\n(VS>40 .vs \\n(VSu
.el .vs \\n(VSp
..
.de C}
.DE
.R
..
.de Pn
.ie t \\$1\fB\^\\$2\^\fR\\$3
.el \\$1\fI\^\\$2\^\fP\\$3
..
.de ZN
.ie t \fB\^\\$1\^\fR\\$2
.el \fI\^\\$1\^\fP\\$2
..
.de NT
.ne 7
.ds NO Note
.if \\n(.$>$1 .if !'\\$2'C' .ds NO \\$2
.if \\n(.$ .if !'\\$1'C' .ds NO \\$1
.ie n .sp
.el .sp 10p
.TB
.ce
\\*(NO
.ie n .sp
.el .sp 5p
.if '\\$1'C' .ce 99
.if '\\$2'C' .ce 99
.in +5n
.ll -5n
.R
..
.		\" Note End -- doug kraft 3/85
.de NE
.ce 0
.in -5n
.ll +5n
.ie n .sp
.el .sp 10p
..
.ny0
.TH XcmsCIELabQueryMax 3X11 "Release 5" "X Version 11" "XLIB FUNCTIONS"
.SH NAME
XcmsCIELabQueryMaxC, XcmsCIELabQueryMaxL, XcmsCIELabQueryMaxLC, XcmsCIELabQueryMinL \- obtain the CIE L*a*b* coordinates
.SH SYNTAX
Status XcmsCIELabQueryMaxC\^(\^\fIccc\fP\^, \fIhue_angle\fP\^, \fIL_star\fP\^, \fIcolor_return\fP\^)
.br
      XcmsCCC \fIccc\fP\^;
.br
      XcmsFloat \fIhue_angle\fP\^;
.br
      XcmsFloat \fIL_star\fP\^;
.br
      XcmsColor *\fIcolor_return\fP\^;
.LP
Status XcmsCIELabQueryMaxL\^(\^\fIccc\fP\^, \fIhue_angle\fP\^, \fIchroma\fP\^, \fIcolor_return\fP\^)
.br
      XcmsCCC \fIccc\fP\^;
.br
      XcmsFloat \fIhue_angle\fP\^;
.br
      XcmsFloat \fIchroma\fP\^;
.br
      XcmsColor *\fIcolor_return\fP\^;
.LP
Status XcmsCIELabQueryMaxLC\^(\^\fIccc\fP\^, \fIhue_angle\fP\^, \fIcolor_return\fP\^)
.br
      XcmsCCC \fIccc\fP\^;
.br
      XcmsFloat \fIhue_angle\fP\^;
.br
      XcmsColor *\fIcolor_return\fP\^;
.LP
Status XcmsCIELabQueryMinL\^(\^\fIccc\fP\^, \fIhue_angle\fP\^, \fIchroma\fP\^, \fIcolor_return\fP\^)
.br
      XcmsCCC \fIccc\fP\^;
.br
      XcmsFloat \fIhue_angle\fP\^;
.br
      XcmsFloat \fIchroma\fP\^;
.br
      XcmsColor *\fIcolor_return\fP\^;
.SH ARGUMENTS
.IP \fIccc\fP 1i
Specifies the CCC.
Note that the CCC's Client White Point and White Point Adjustment procedures
are ignored.
.ds Ch maximum lightness (MaxL) or minimum lightness (MinL)
.IP \fIchroma\fP 1i
Specifies the chroma at which to find \*(Ch.
.ds Lc maximum chroma (MaxC and MaxLC), maximum lightnes (MaxL), \
or minimum lightness (MinL)
.ds lC hue angle and lightness (MaxC), hue angle and chroma (MaxL and MinL), \
or hue angle (MaxLC)
.IP \fIcolor_return\fP 1i
Returns the CIE L*a*b* coordinates of \*(Lc
displayable by the screen for the given \*(lC.
The white point associated with the returned
color specification is the Screen White Point.
The value returned in the pixel member is undefined.
.ds Ha maximum chroma (MaxC and MaxLC), maximum lightness (MaxL), \
or minimum lightness (MinL)
.IP \fIhue_angle\fP 1i
Specifies the hue angle in degrees at which to find \*(Ha.
.ds Ls maximum chroma (MaxC)
.IP \fIL_star\fP 1i
Specifies the lightness (L*) at which to find \*(Ls.
.SH DESCRIPTION
The
.ZN XcmsCIELabQueryMaxC
function, given a hue angle and lightness,
finds the point of maximum chroma displayable by the screen.
It returns this point in CIE L*a*b* coordinates.
.LP
The
.ZN XcmsCIELabQueryMaxL
function, given a hue angle and chroma,
finds the point in CIE L*a*b* color space of maximum 
lightness (L*) displayable by the screen.
It returns this point in CIE L*a*b* coordinates.
An 
.ZN XcmsFailure
return value usually indicates that the given chroma
is beyond maximum for the given hue angle.
.LP
The
.ZN XcmsCIELabQueryMaxLC
function, given a hue angle,
finds the point of maximum chroma displayable by the screen.
It returns this point in CIE L*a*b* coordinates.
.LP
The
.ZN XcmsCIELabQueryMinL
function, given a hue angle and chroma,
finds the point of minimum lightness (L*) displayable by the screen.
It returns this point in CIE L*a*b* coordinates.
An 
.ZN XcmsFailure
return value usually indicates that the given chroma
is beyond maximum for the given hue angle.
.SH "SEE ALSO"
XcmsCIELuvQueryMaxC(3X11),
XcmsTekHVCQueryMaxC(3X11),
XcmsQueryBlack(3X11)
.br
\fI\*(xL\fP
