.ds tk X Toolkit
.ds xT X Toolkit Intrinsics \- C Language Interface
.ds xI Intrinsics
.ds xW X Toolkit Athena Widgets \- C Language Interface
.ds xL Xlib \- C Language X Interface
.ds xC Inter-Client Communication Conventions Manual
.ds Rn 3
.ds Vn 2.2
.hw XtMake-Geometry-Request XtQuery-Geometry wid-get
.na
.de Ds
.nf
.\\$1D \\$2 \\$1
.ft 1
.ps \\n(PS
.\".if \\n(VS>=40 .vs \\n(VSu
.\".if \\n(VS<=39 .vs \\n(VSp
..
.de De
.ce 0
.if \\n(BD .DF
.nr BD 0
.in \\n(OIu
.if \\n(TM .ls 2
.sp \\n(DDu
.fi
..
.de FD
.LP
.KS
.TA .5i 3i
.ta .5i 3i
.nf
..
.de FN
.fi
.KE
.LP
..
.de IN		\" send an index entry to the stderr
..
.de C{
.KS
.nf
.D
.\"
.\"	choose appropriate monospace font
.\"	the imagen conditional, 480,
.\"	may be changed to L if LB is too
.\"	heavy for your eyes...
.\"
.ie "\\*(.T"480" .ft L
.el .ie "\\*(.T"300" .ft L
.el .ie "\\*(.T"202" .ft PO
.el .ie "\\*(.T"aps" .ft CW
.el .ft R
.ps \\n(PS
.ie \\n(VS>40 .vs \\n(VSu
.el .vs \\n(VSp
..
.de C}
.DE
.R
..
.de Pn
.ie t \\$1\fB\^\\$2\^\fR\\$3
.el \\$1\fI\^\\$2\^\fP\\$3
..
.de ZN
.ie t \fB\^\\$1\^\fR\\$2
.el \fI\^\\$1\^\fP\\$2
..
.de NT
.ne 7
.ds NO Note
.if \\n(.$>$1 .if !'\\$2'C' .ds NO \\$2
.if \\n(.$ .if !'\\$1'C' .ds NO \\$1
.ie n .sp
.el .sp 10p
.TB
.ce
\\*(NO
.ie n .sp
.el .sp 5p
.if '\\$1'C' .ce 99
.if '\\$2'C' .ce 99
.in +5n
.ll -5n
.R
..
.		\" Note End -- doug kraft 3/85
.de NE
.ce 0
.in -5n
.ll +5n
.ie n .sp
.el .sp 10p
..
.ny0
.TH XtAppGetSelectionTimeout 3Xt "Release 3" "X Version 11" "XT FUNCTIONS"
.SH NAME
XtAppGetSelectionTimeout, XtAppSetSelectionTimeout \- set and obtain selection timeout values
.SH SYNTAX
unsigned long XtAppGetSelectionTimeout(\fIapp_context\fP)
.br
     XtAppContext \fIapp_context\fP;
.LP
void XtAppSetSelectionTimeout(\fIapp_context\fP, \fItimeout\fP)
.br
    XtAppContext \fIapp_context\fP;
.br
    unsigned long \fItimeout\fP;
.SH ARGUMENTS
.IP \fIapp_context\fP 1i
Specifies the application context.
.IP \fItimeout\fP 1i
Specifies the selection timeout in milliseconds.
.SH DESCRIPTION
The
.ZN XtAppGetSelectionTimeout
function returns the current selection timeout value, in milliseconds.
The selection timeout is the time within which the two communicating 
applications must respond to one another.
The initial timeout value is set by the 
.ZN selectionTimeout
application resource, or, if
.ZN selectionTimeout
is not specified,
it defaults to five seconds.
.LP
The
.ZN XtAppSetSelectionTimeout
function sets the \*(xI's selection timeout mechanism.
Note that most applications should not set the selection timeout.
.SH "SEE ALSO"
XtOwnSelection(3Xt)
.br
\fI\*(xT\fP
.br
\fI\*(xL\fP
