.ds tk X Toolkit
.ds xT X Toolkit Intrinsics \- C Language Interface
.ds xI Intrinsics
.ds xW X Toolkit Athena Widgets \- C Language Interface
.ds xL Xlib \- C Language X Interface
.ds xC Inter-Client Communication Conventions Manual
.ds Rn 3
.ds Vn 2.2
.hw XtMake-Geometry-Request XtQuery-Geometry wid-get
.na
.de Ds
.nf
.\\$1D \\$2 \\$1
.ft 1
.ps \\n(PS
.\".if \\n(VS>=40 .vs \\n(VSu
.\".if \\n(VS<=39 .vs \\n(VSp
..
.de De
.ce 0
.if \\n(BD .DF
.nr BD 0
.in \\n(OIu
.if \\n(TM .ls 2
.sp \\n(DDu
.fi
..
.de FD
.LP
.KS
.TA .5i 3i
.ta .5i 3i
.nf
..
.de FN
.fi
.KE
.LP
..
.de IN		\" send an index entry to the stderr
..
.de C{
.KS
.nf
.D
.\"
.\"	choose appropriate monospace font
.\"	the imagen conditional, 480,
.\"	may be changed to L if LB is too
.\"	heavy for your eyes...
.\"
.ie "\\*(.T"480" .ft L
.el .ie "\\*(.T"300" .ft L
.el .ie "\\*(.T"202" .ft PO
.el .ie "\\*(.T"aps" .ft CW
.el .ft R
.ps \\n(PS
.ie \\n(VS>40 .vs \\n(VSu
.el .vs \\n(VSp
..
.de C}
.DE
.R
..
.de Pn
.ie t \\$1\fB\^\\$2\^\fR\\$3
.el \\$1\fI\^\\$2\^\fP\\$3
..
.de ZN
.ie t \fB\^\\$1\^\fR\\$2
.el \fI\^\\$1\^\fP\\$2
..
.de NT
.ne 7
.ds NO Note
.if \\n(.$>$1 .if !'\\$2'C' .ds NO \\$2
.if \\n(.$ .if !'\\$1'C' .ds NO \\$1
.ie n .sp
.el .sp 10p
.TB
.ce
\\*(NO
.ie n .sp
.el .sp 5p
.if '\\$1'C' .ce 99
.if '\\$2'C' .ce 99
.in +5n
.ll -5n
.R
..
.		\" Note End -- doug kraft 3/85
.de NE
.ce 0
.in -5n
.ll +5n
.ie n .sp
.el .sp 10p
..
.ny0
.TH XtNameToWidget 3Xt "Release 3" "X Version 11" "XT FUNCTIONS"
.SH NAME
XtNameToWidget, XtWidgetToWindow \- translating strings to widgets or widgets to windows
.SH SYNTAX
Widget XtNameToWidget(\fIreference\fP, \fInames\fP);
.br
      Widget \fIreference\fP;
.br
      String \fInames\fP;
.LP
Widget XtWindowToWidget(\fIdisplay\fP, \fIwindow\fP)
.br
      Display *\fIdisplay\fP;
.br
      Window \fIwindow\fP;
.SH ARGUMENTS
.ds Di \ on which the window is defined
.IP \fIdisplay\fP 1i
Specifies the display\*(Di.
.IP \fInames\fP 1i
Specifies the fully qualified name of the desired widget.
.IP \fIreference\fP 1i
Specifies the widget from which the search is to start.
.IP \fIwindow\fP 1i
Specify the window for which you want the widget.
.SH DESCRIPTION
The
.ZN XtNameToWidget
function looks for a widget whose name is the first component in the specified
names and that is a pop-up child of reference (or a normal child if reference
is a subclass of
.ZN compositeWidgetClass ).
It then uses that widget as the new reference and repeats the search
after deleting the first component from the specified names.
If it cannot find the specified widget,
.ZN XtNameToWidget
returns NULL.
.LP
Note that the names argument contains the name of a widget with respect to the 
specified reference widget and can contain more than one widget name
(separated by periods) for widgets that are not direct children 
of the specified reference widget.
.LP
If more than one child of the reference widget matches the name,
.ZN XtNameToWidget
can return any of the children.
The \*(xI do not require that all children of a widget have unique names.
If the specified names contain more than one component
and if more than one child matches the first component,
.ZN XtNameToWidget
can return NULL if the single branch that it follows does not
contain the named widget.
That is,
.ZN XtNameToWidget
does not back up and follow other matching branches of the widget tree.
.LP
The
.ZN XtWindowToWidget
function translates the specified window and display pointer into the
appropriate widget instance.
.SH "SEE ALSO"
.br
\fI\*(xT\fP
.br
\fI\*(xL\fP
