.ds tk X Toolkit
.ds xT X Toolkit Intrinsics \- C Language Interface
.ds xI Intrinsics
.ds xW X Toolkit Athena Widgets \- C Language Interface
.ds xL Xlib \- C Language X Interface
.ds xC Inter-Client Communication Conventions Manual
.ds Rn 3
.ds Vn 2.2
.hw XtMake-Geometry-Request XtQuery-Geometry wid-get
.na
.de Ds
.nf
.\\$1D \\$2 \\$1
.ft 1
.ps \\n(PS
.\".if \\n(VS>=40 .vs \\n(VSu
.\".if \\n(VS<=39 .vs \\n(VSp
..
.de De
.ce 0
.if \\n(BD .DF
.nr BD 0
.in \\n(OIu
.if \\n(TM .ls 2
.sp \\n(DDu
.fi
..
.de FD
.LP
.KS
.TA .5i 3i
.ta .5i 3i
.nf
..
.de FN
.fi
.KE
.LP
..
.de IN		\" send an index entry to the stderr
..
.de C{
.KS
.nf
.D
.\"
.\"	choose appropriate monospace font
.\"	the imagen conditional, 480,
.\"	may be changed to L if LB is too
.\"	heavy for your eyes...
.\"
.ie "\\*(.T"480" .ft L
.el .ie "\\*(.T"300" .ft L
.el .ie "\\*(.T"202" .ft PO
.el .ie "\\*(.T"aps" .ft CW
.el .ft R
.ps \\n(PS
.ie \\n(VS>40 .vs \\n(VSu
.el .vs \\n(VSp
..
.de C}
.DE
.R
..
.de Pn
.ie t \\$1\fB\^\\$2\^\fR\\$3
.el \\$1\fI\^\\$2\^\fP\\$3
..
.de ZN
.ie t \fB\^\\$1\^\fR\\$2
.el \fI\^\\$1\^\fP\\$2
..
.de NT
.ne 7
.ds NO Note
.if \\n(.$>$1 .if !'\\$2'C' .ds NO \\$2
.if \\n(.$ .if !'\\$1'C' .ds NO \\$1
.ie n .sp
.el .sp 10p
.TB
.ce
\\*(NO
.ie n .sp
.el .sp 5p
.if '\\$1'C' .ce 99
.if '\\$2'C' .ce 99
.in +5n
.ll -5n
.R
..
.		\" Note End -- doug kraft 3/85
.de NE
.ce 0
.in -5n
.ll +5n
.ie n .sp
.el .sp 10p
..
.ny0
.TH XtParseTranslationTable 3Xt "Release 3" "X Version 11" "XT FUNCTIONS"
.SH NAME
XtParseTranslationTable, XtAugmentTranslations, XtOverrideTranslations, XtUninstallTranslations \- manage translation tables
.SH SYNTAX
XtTranslations XtParseTranslationTable(\fItable\fP)
.br
      String \fItable\fP;
.LP
void XtAugmentTranslations(\fIw\fP, \fItranslations\fP)
.br
      Widget \fIw\fP;
.br
      XtTranslations \fItranslations\fP;
.LP
void XtOverrideTranslations(\fIw\fP, \fItranslations\fP)
.br
      Widget \fIw\fP;
.br
      XtTranslations \fItranslations\fP;
.LP
void XtUninstallTranslations(\fIw\fP)
.br
      Widget \fIw\fP;
.SH ARGUMENTS
.IP \fItable\fP 1i
Specifies the translation table to compile.
.IP \fItranslations\fP 1i
Specifies the compiled translation table to merge in (must not be NULL).
.ds Wi into which the new translations are to be merged or removed
.IP \fIw\fP 1i
Specifies the widget \*(Wi.
.SH DESCRIPTION
The
.ZN XtParseTranslationTable
function compiles the translation table into the opaque internal representation
of type
.ZN XtTranslations .
Note that if an empty translation table is required for any purpose,
one can be obtained by calling
.ZN XtParseTranslationTable
and passing an empty string.
.LP
The
.ZN XtAugmentTranslations
function nondestructively merges the new translations into the existing widget
translations.
If the new translations contain an event or event sequence that
already exists in the widget's translations,
the new translation is ignored.
.LP
The
.ZN XtOverrideTranslations
function destructively merges the new translations into the existing widget
translations.
If the new translations contain an event or event sequence that
already exists in the widget's translations,
the new translation is merged in and override the widget's translation.
.LP
To replace a widget's translations completely, use
.ZN XtSetValues
on the XtNtranslations resource and specifiy a compiled translation table
as the value.
.LP
The
.ZN XtUninstallTranslations
function causes the entire translation table for widget to be removed.
.SH "SEE ALSO"
XtAppAddActions(3Xt),
XtCreatePopupShell(3Xt),
XtParseAcceleratorTable(3Xt),
XtPopup(3Xt)
.br
\fI\*(xT\fP
.br
\fI\*(xL\fP
